# Contributing

Are you interested in contributing code to Kotter? First of all, let me say -- thanks! I really mean it. I appreciate
your time and that you're giving some of it to this project.

As it's still very early in the life of the project, the requirements set out for now will be pretty minimal, but I
expect to tighten them over time as the project stabilizes.

First of all, **be aware of our code of conduct**

* For now, we're borrowing almost wholesale from the
  [Rust Code of conduct](https://www.rust-lang.org/policies/code-of-conduct)
* TL;DR - debate is welcome to generate the best ideas, but respect each other. We'll never tolerate behavior where
  someone is affecting the community negatively or attacking people and not ideas.

Other than that, just a few rules:

* **Code consistency and readability are the highest priorities right now**
    * Consider using IntelliJ IDEA (Community Edition is fine). This way, we can set common project settings in a file
      and lean on the tools to resolve disagreements, so we can focus on more interesting work.
    * Changes should be tested.
* **Pull requests should be associated with a bug that you have assigned to yourself**
    * This ensures that we won't have multiple people working on the same issue at the same time
* **New features should be discussed with me first**
    * This ensures that you won't waste your time on something I might have reasons to reject.
    * Of course, pull requests can be an effective way of proposing a feature, so go for it as long as you're OK that
      there are no guarantees we'll take the change.
    * Ways to connect:
        * [Join my Discord!](https://discord.gg/5NZ2GKV5Cs)
        * Follow me on Twitter: [@bitspittle](https://twitter.com/bitspittle)
        * You can send direct queries to [my email](mailto:bitspittle@gmail.com).

These rules are NOT dogma. I am always open to exceptions, but be ready to explain why your situation is special!

Thank you, again, for choosing to help out on Kotter.